/*
Wolfbird Config

Author: Bernhard Jaud
Email: bernhard@becast.at
Version: 0.3
Date: 11/08/2009
License: GPL v2
Web: www.becast.at

*/

Importer.loadQtBinding( "qt.core");
Importer.loadQtBinding( "qt.gui");
Importer.loadQtBinding( "qt.uitools" );

var config= Array();
var cproc = new QProcess();
var helpWin = new helpWindow();

try {
	var configEdit = new configurationEditor();

	Amarok.Window.addSettingsMenu("configtwitterok","Configure WolfBird...",Amarok.Info.scriptPath()+"/icons/twitterconf.png");
	Amarok.Window.SettingsMenu.configtwitterok['triggered()'].connect( configureDialog ); 
} catch ( err ) {
	Amarok.debug ( err );
}


function helpWindow() {
	this.window = new QWidget(this);
	
	this.showen = 0;
	
	this.show = function() {
		this.window.show();
		this.showen = 1;
	};
	
	this.close = function() {
		this.showen = 0;
		this.window.close();
	};
	
	helptext = "<h3>Configure Wolfbird</h3><br>";
	helptext += "<i>Wolfbird a little Script that lets you Tweet your songs Manually or automagically!</i><br>";
	helptext += "<u>Twitter Username</u><br><i>Your Twitter Username.<br><u>Twitter Password</u><br><i>Your Twitter Password.<br><u>Twitter Message</u><br><i>The message that should be tweeted. For a list of Keywords look below.<br><u>Tweet on Trackchange</u><i><br>Should Amarok tweet your Songs on every change? <strong>Warning! This may annoy your followers</strong></i><br><br>The following Keywords are replaced:</i><ul><li><b>%%Songtitle%%</b> is replaced with the Title of the Song</li><li><b>%%Songartist%%</b> is replaced with the Artist of the Song</li><li><b>%%Songlength%%</b> is replaced with the length of the Song</li><li><b>%%Songalbum%%</b> is replaced with the Album of the Song</li><li><b>%%Songtrack%%</b> is replaced with the Track No. of the Song</li><li><b>%%Songgenre%%</b> is replaced with the Genre of the Song</li><li><b>%%Songyear%%</b> is replaced with the publishing year of the Song</li><li><b>%%Songcomment%%</b> is replaced with the Comment to the Song</li><li><b>%%Songscore%%</b> is replaced with the Score of the Song</li><li><b>%%Songrating%%</b> is replaced with the Rating of the Song</li><li><b>%%Songplaycount%%</b> is replaced with the Playcount of the Song</li></ul></i>";
	helptext += "<u>Use Countdown before tweeting?</u><br><i>Should Wolfbird wait to send updates to Twitter?<br>You can abort the update by clicking the \"Tweet it\" Button.<br><u>Countdowntime</u><br><i>The amount of time Wolfbird waits until the updates are sent.</i>";
	
	
	
	this.text = new QTextEdit(helptext,this);
	this.text.readOnly = true;
	this.layout = new QVBoxLayout(this.window);
	this.layout.addWidget(this.text,0,0);

	this.window.setLayout(this.layout);
	this.window.sizeHint = new QSize(350,450);
	this.window.size = new QSize(350,450);
	this.window.move(695,240);
	this.window.setWindowTitle("Help - Configure Wolfbird");
	this.window.windowIcon=new QIcon(Amarok.Info.scriptPath()+"/icons/help.png");
	
	return true;
}

function configurationEditor() {
	this.window = new QMainWindow(this);
	this.dlg =new QWidget(this);

	this.accept = function () {
		this.saveConfiguration();
		helpWin.close();
		this.window.close();
	};

	this.close = function() {
		cproc.kill();
		helpWin.close();
		this.window.close();
	};
	
	this.help = function() {
		if (helpWin.showen){
			helpWin.close();
		}
		else{
			helpWin.show();
		}
	};

	this.show = function() {
		this.window.show();
	};
	

	
	this.web = function (info) {
		firefox = new QProcess();
		firefox.start("firefox",["http://www.becast.at"]);
	};

	this.readConfiguration = function() {
		try {
			config["username"]=Amarok.Script.readConfig("twitter_user","User");
			config["password"] = Amarok.Script.readConfig("twitter_pass","Pass");
			config["message"] = Amarok.Script.readConfig("twitter_msg","I'm listening to %%Songtitle%% by %%Songartist%% (%%Songlength%%)");
			config["onchange"] = Amarok.Script.readConfig("twitter_onchange","false");
			config["usecountdown"] = Amarok.Script.readConfig("twitter_countdown","true");
			config["countdown"] = Amarok.Script.readConfig("twitter_countdowncount","10");

		} catch(err) {
			Amarok.debug('error: ' + err);
		}
		return true;
	};

	this.saveConfiguration = function() {
		try {
			
			config["username"] = this.userInput.text;
			config["password"] = this.passInput.text;
			config["message"] = this.messageInput.text;
			config["onchange"] = this.onchangeCheck.checkState().toString();
			if(config["onchange"]=="Checked"){
				config["onchange"]="true";
			}else{
				config["onchange"]="false";
			}
			config["countdown"] = this.countdownInput.value;
			config["usecountdown"] = this.usecountdownCheck.checkState().toString();
			if(config["usecountdown"]=="Checked"){
				config["usecountdown"]="true";
			}else{
				config["usecountdown"]="false";
			}
			Amarok.Script.writeConfig("twitter_user",config["username"]);
			Amarok.Script.writeConfig("twitter_pass",config["password"]);
			Amarok.Script.writeConfig("twitter_msg",config["message"]);
			Amarok.Script.writeConfig("twitter_onchange",config["onchange"]);
			Amarok.Script.writeConfig("twitter_countdown",config["usecountdown"]);
			Amarok.Script.writeConfig("twitter_countdowncount",config["countdown"].toString());
			

		} catch(err) {
			Amarok.debug('error: ' + err);
		}
		return true;
	};
	
	
	this.readConfiguration();
	this.tabs = new QTabWidget();

	this.logoBox = new QHBoxLayout();
	this.logo = new QPixmap(Amarok.Info.scriptPath()+"/icons/wolfbird.png");
	this.logoLabel = new QLabel("", this.dlg);
	this.logoLabel.setPixmap(this.logo);
	//this.logoBox.setAlignment(this.logoBox, Qt.AlignCenter);
	this.logoBox.addWidget(this.logoLabel,0,Qt.AlignCenter);

	this.userBox = new QHBoxLayout();
	this.userLabel = new QLabel("Twitter Username:", this.dlg);
	this.userInput = new QLineEdit(config["username"]);
	this.userBox.addWidget(this.userLabel,0,0);
	this.userBox.addWidget(this.userInput,0,0);
	
	this.passBox = new QHBoxLayout()
	this.passLabel = new QLabel("Twitter Passwort:", this.dlg);
	this.passInput = new QLineEdit(config["password"]);
	this.passInput.echoMode = QLineEdit.Password;
	this.passBox.addWidget(this.passLabel,0,0);
	this.passBox.addWidget(this.passInput,0,0);

	this.messageBox = new QHBoxLayout()
	this.messageLabel = new QLabel("Twitter Message:", this.dlg);
	this.messageInput = new QLineEdit(config["message"]);
	this.messageBox.addWidget(this.messageLabel,0,0);
	this.messageBox.addWidget(this.messageInput,0,0);


	this.onchangeBox = new QHBoxLayout()
	this.onchangeCheck = new QCheckBox("Tweet on Trackchange");
	if(config["onchange"]=="false"){
		this.onchangeCheck.checked = false;
	}else{
		
		this.onchangeCheck.checked = true;
	}
	this.onchangeBox.addWidget(this.onchangeCheck,0,0);
	
	this.usecountdownBox = new QHBoxLayout()
	this.usecountdownCheck = new QCheckBox("Use Countdown before tweeting?");
	if(config["usecountdown"]=="false"){
		this.usecountdownCheck.checked = false;
	}else{
		
		this.usecountdownCheck.checked = true;
	}
	this.usecountdownBox.addWidget(this.usecountdownCheck,0,0);

	this.countdownBox = new QHBoxLayout()
	this.countdownLabel = new QLabel("Countdowntime:", this.dlg);
	this.countdownInput = new QSpinBox();
	this.countdownInput.setRange(0,86400);
	this.countdownInput.setValue(config["countdown"]);
	this.countdownBox.addWidget(this.countdownLabel,0,0);
	this.countdownBox.addWidget(this.countdownInput,0,0);

	this.playBox = new QVBoxLayout();
	this.playBox.addLayout(this.logoBox);
	this.playBox.addLayout(this.userBox);
	this.playBox.addLayout(this.passBox);
	this.playBox.addLayout(this.messageBox);
	this.playBox.addLayout(this.onchangeBox);
	this.playBox.addLayout(this.usecountdownBox);
	this.playBox.addLayout(this.countdownBox);

	this.playTab = new QWidget();
	this.playTab.setLayout(this.playBox);

	this.buttonBox = new QDialogButtonBox();
	this.buttonBox.addButton( QDialogButtonBox.Help );
	this.buttonBox.addButton( QDialogButtonBox.Ok );
	this.buttonBox.addButton( QDialogButtonBox.Cancel );
	this.buttonBox.accepted.connect( this, this.accept );
	this.buttonBox.rejected.connect( this, this.close );
	this.buttonBox.helpRequested.connect( this, this.help );

	this.vblMain = new QVBoxLayout(this.dlg);
	this.vblMain.addWidget(this.playTab,0,0);
	this.vblMain.addWidget(this.buttonBox,0,0);

	this.dlg.setLayout(this.vblMain);
	this.dlg.sizeHint = new QSize(400,250);
	this.dlg.size = new QSize(400,250);
	this.dlg.minimumSize = new QSize(400,250);
	this.window.move(320,240);
	this.window.setWindowTitle("Configure Wolfbird - Amarok");
	this.window.windowIcon=new QIcon(Amarok.Info.scriptPath()+"/icons/config.png");
	this.window.setCentralWidget(this.dlg);

	this.helpMenu = this.window.menuBar().addMenu("Help");
	this.helpHelp = this.helpMenu.addAction("Help");
	this.helpHelp.triggered.connect(this,this.help);
	this.helpWeb = this.helpMenu.addAction("Website");
	this.helpWeb.triggered.connect(this,this.web);

	
	return true;
}


function configureDialog() {
	configEdit.readConfiguration();
	configEdit.show();
}
