/*
Wolfbird

Author: Bernhard Jaud
Email: bernhard@becast.at
Version: 0.4
Date: 02/16/2010
License: GPL v2
Web: www.becast.at

*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");
Importer.loadQtBinding("qt.uitools");
Importer.loadQtBinding("qt.network");
Importer.include("config.js");


function Track() {
    this.init = init;
    this.init();
    this.timer = timer;
    this.timer();
    this.trigger = "";
    x = this;
	Amarok.Window.addToolsMenu("twitter", "Twitter it",Amarok.Info.scriptPath()+"/icons/twitter.png");
	Amarok.Window.ToolsMenu.twitter['triggered()'].connect(function() { x.twitter_manual();});
	Amarok.Engine.trackChanged.connect(function() { x.onTrackChange();});
}
Track.prototype.prepareMsg = prepareMsg;
Track.prototype.sendMsg = sendMsg;
Track.prototype.countdown = countdown;
Track.prototype.timerRun = timerRun;
Track.prototype.twitter_manual = twitter_manual;
Track.prototype.twitter = twitter;
Track.prototype.onTrackChange = onTrackChange;

function init(){
	this.timerrunning=false;
	this.timercount=parseInt(Amarok.Script.readConfig("twitter_countdowncount","10"));
	this.timerstat=0;
}

function timer(){
	this.timeTimer = new QTimer(); 
	var x = this;
	this.timeTimer.timeout.connect(function() { x.timerRun(); });
}

function prepareMsg(){
	var msg = Amarok.Script.readConfig("twitter_msg","I'm listening to %%Songtitle%% by %%Songartist%% (%%Songlength%%)");
	artist = Amarok.Engine.currentTrack().artist;
	title = Amarok.Engine.currentTrack().title;
	length = (Amarok.Engine.currentTrack().length >= 3600 ?
		(new QTime()).addSecs(Amarok.Engine.currentTrack().length - 0).toString("hh:mm:ss") :
		(new QTime()).addSecs(Amarok.Engine.currentTrack().length - 0).toString("mm:ss"));
	album = Amarok.Engine.currentTrack().album;
	track = Amarok.Engine.currentTrack().trackNumber;
	genre = Amarok.Engine.currentTrack().genre;
	year = Amarok.Engine.currentTrack().year;
	comment = Amarok.Engine.currentTrack().comment;
	score = Amarok.Engine.currentTrack().score;
	rating = Amarok.Engine.currentTrack().rating;
	playcount = Amarok.Engine.currentTrack().playCount;
	msg=msg.replace("%%Songartist%%", artist);
	msg=msg.replace("%%Songtitle%%", title);
	msg=msg.replace("%%Songlength%%", length);
	msg=msg.replace("%%Songalbum%%", album);
	msg=msg.replace("%%Songtrack%%", track);
	msg=msg.replace("%%Songgenre%%", genre);
	msg=msg.replace("%%Songyear%%", year);
	msg=msg.replace("%%Songcomment%%", comment);
	msg=msg.replace("%%Songscore%%", score);
	msg=msg.replace("%%Songrating%%", rating);
	msg=msg.replace("%%Songplaycount%%", playcount);
	msg=msg.replace("%", "%25");
	msg=msg.replace("&", "%26");
	msg=msg.replace("#", "%23");
	msg=msg.replace("+", "%2B");
	msg=msg.replace("?", "%3F");
	msg=msg.replace("$", "%24");
	msg=msg.replace("=", "%3D");
	this.msg=msg;

}

function sendMsg(){
	http = new QHttp;
	var user=Amarok.Script.readConfig("twitter_user","");
	var pass=Amarok.Script.readConfig("twitter_pass","");
	http.setHost("www.twitter.com");
	http.setUser(user, pass);
	http.done.connect(onDownloadTranslate);
	http.post("/statuses/update.xml", Amarok.Lyrics.fromUtf8('status=' + this.msg, 'UTF-8'));
}

function countdown(){

	var countdownvar=Amarok.Script.readConfig("twitter_countdown","true");

	if(countdownvar=="true"){
		if(this.timerrunning==true){
			this.timeTimer.stop();
			this.init();

		}
		    	
		var x = this;
		this.init();
		this.timerrunning=true;
		this.timeTimer.start(1000);
	}else{
		this.sendMsg();
	}
}

function timerRun(){
	this.timerstat++;
	print(this.timerstat);
	if(this.timerstat>=this.timercount){
		this.timeTimer.stop();
		this.init();
		this.sendMsg();
	}else{
		time=this.timercount-this.timerstat;
		Amarok.Window.Statusbar.shortMessage("Going to Tweet Song in " + time + " seconds. Klick \"Twitter it\" to cancel.");
	}
}

function twitter_manual(){
	if(Amarok.Engine.engineState() < 2){
		if(this.timerrunning==true){
			this.timeTimer.stop();
			this.init();
		}else{
			this.prepareMsg();	
			this.countdown();
		}
	}
}

function twitter(){
	this.prepareMsg();
	this.countdown();
}

function onDownloadTranslate() {
	var str=Amarok.Lyrics.toUtf8(http.readAll());
	  Amarok.debug(str);
	if(str!=""){
		Amarok.Window.Statusbar.shortMessage("Song tweeted!");
	}else{
		Amarok.Window.Statusbar.shortMessage("Error! Couldn't tweet Song!");
	}
} // function onDownloadTranslate()

// notification when a new track is started
function onTrackChange(){
	var update=Amarok.Script.readConfig("twitter_onchange","false");
	if(update=="true"){
		this.twitter();
	}
}
var track = new Track();

